<template>
  <div class="roles">
    <div class="wp-field wp-field--notify wp-12"
      v-if="$props.roles.length === 0">
      Роли не назначены
    </div>
    <div v-else class="wp-12 roles-list">
      <div class="list-title">
        <div class="title-text">
          Название
        </div>
        <div class="wp-indicators wp-indicators--title">
          <div class="wp-indicator">D</div>
        </div>
      </div>
      <div class="list-content">
        <div class="list-content__row" v-for="role in $props.roles" :key="role.id">
          <div class="row-text">
            {{ getRoleName(role.id) }}
          </div>
          <div class="wp-indicators">
            <div class="wp-indicator"
              :class="{
                'wp-indicator--primary': role.display,
                'wp-indicator--secondary': !role.display,
              }"></div>
          </div>
          <div class="row-action" @click="$emit('delete', role)">
            <font-awesome-icon icon="trash" size="xs" class="row-action__icon"/>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { mapState, mapGetters } from 'vuex';

export default {
  name: 'UserRolesTable',
  props: {
    roles: {
      type: Array,
      required: true,
    },
  },
  computed: {
    ...mapState('organization', ['organization']),
    ...mapGetters('organization', ['roleByID']),
  },
  methods: {
    getRoleName(roleID) {
      if (roleID === null) return 'Общее разрешение';
      return this.roleByID[roleID];
    },
  },
};
</script>

<style lang="scss" scoped>
.roles {
  margin-bottom: 15px;

  &-list {
    margin-bottom: 10px;

    .list {

      &-title {
        margin-bottom: 5px;
        display: flex;
        align-items: center;

        > .wp-indicators {
          margin-right: 25px;
        }

        .title {

          &-text {
            font-size: 15px;
            font-family: $firaSans;
            color: $neutralDarker;
          }

        }

      }

      &-content {

        &__row {
          margin-bottom: 5px;
          display: flex;
          align-items: center;

          > .wp-indicators {
            margin-right: 10px;
          }

          .row {

            &-text {
              font-size: 15px;
              font-family: $roboto;
            }

            &-action {
              height: 15px;
              width: 15px;
              display: flex;
              justify-content: center;
              align-items: center;

              &__icon {
                color: $neutralDark;
                transition: color ease-in-out .2s;
              }

              &:hover {
                cursor: pointer;

                .row-action__icon {
                  color: $secondary;
                }

              }

            }

          }

        }

      }

    }

  }

}
</style>
